/* Show disabled elements with less impactful text color. */
form *[disabled]
{
	color: var(--disabled-text);
}

/**/
form
{
	display: flex !important;
	flex-direction: column;
	justify-content: flex-start;

	height: 100%;
	max-width: 40ex;
	margin: auto !important;
}

/* Make checkboxes fixed-size and apply a small margin to prevent label texts from getting too close. */
input[type="checkbox"]
{
	flex-grow: 0;
	margin: var(--space-small);
	margin-right: var(--space-small);
}

fieldset
{
	display: block;
	border: 0;
}

input[readonly]
{
	color: var(--disabled-text);
}

/* Highlight invalid fields with red glow on their text and border outlines. */
input:not(:placeholder-shown):invalid
{
	text-shadow: 0 0 var(--space-small) var(--negative) !important;
	box-shadow:
		inset 0 var(--shadow-position) var(--shadow-blur) var(--shadow-color),
		0 0 var(--space-tiny) var(--space-tiny) var(--negative)
		!important;
}

/* */
fieldset > div
{
	width: 100%;

	display: flex;
	flex-direction: column;
	justify-content: center;
	align-items: stretch;

	padding: 0.75rem 1.00rem;
	padding-bottom: var(--space-thick);
}

/* Styling for all regular user input fields (not dropdowns, checkboxes or radioboxes) */
input[type="number"],
input[type="text"]
{
	width: 100%;
	height: 2rem;

	font-family: monospace;
	line-height: 1.25rem;
	padding: var(--space-huge);
	padding-bottom: var(--space-normal);
	overflow: hidden;
	text-overflow: ellipsis;
	color: var(--text-muted);
	background-color: var(--odd);
	border: var(--space-tiny) solid var(--border-muted);
	box-shadow: inset 0rem var(--shadow-position) var(--shadow-blur) var(--shadow-color);
}

/* Add a small space between inputs and their subtexts, to prevent a cramped feeling. */
input + small
{
	margin-top: var(--space-small);
}

/* Align subtexts second span to the right, to allow for left and right aligned entries. */
input + small > span:nth-child(2)
{
	float: right;
}

/* Set the main entry text for buttons to take up the full width, so subtexts don't end up on the same line. */
button[type='submit'] > span:first-child
{
	width: 100%;
}

button[type='submit']
{
	height: 3.5rem;
	border-radius: var(--radius-outer);

	background-color: var(--disabled-color);
	border: var(--space-small) solid var(--background);
	box-shadow: 0rem var(--shadow-position) var(--shadow-blur) var(--shadow-color);
	outline: var(--space-tiny) solid var(--border-muted);
}

button[type='submit'].valid
{
	color: var(--text);
	background-color: var(--primary-focus);
	box-shadow: 0rem var(--shadow-position) var(--shadow-blur) var(--shadow-color);

	cursor: pointer;
}

/* Container for inputs that should have an icon (e.g. Copy to Clipboard) */
.inputWithIconContainer {
	width: 100%;

	display: flex;
	margin-bottom: var(--space-small);

	background-color: var(--odd);
}

/* Align subtexts second span to the right, to allow for left and right aligned entries. */
.inputWithIconContainer + small > span:nth-child(2)
{
	float: right;
}

/* Icon container to be used within above container */
.inputIcon
{
	display: flex;
	align-items: center;

	border: var(--space-tiny) solid var(--border-muted);
	border-left: none;
	padding-left: 0.3em;
	padding-right: 0.3em;

	cursor: pointer;
}
